<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="keepName" label="名称">
                <el-input v-model="formData.keepName"></el-input>
            </el-form-item>
            <el-form-item prop="position" label="职位">
                <el-input v-model="formData.position"></el-input>
            </el-form-item>
            <el-form-item prop="icon" label="头像">
                <single-upload v-model="formData.icon"></single-upload>
            </el-form-item>
            <el-form-item prop="telephone" label="电话">
                <el-input v-model="formData.telephone"></el-input>
            </el-form-item>
            <el-form-item prop="sex" label="性别">
                <el-input v-model="formData.sex"></el-input>
            </el-form-item>
            <el-form-item prop="introduce" label="介绍">
                <el-input v-model="formData.introduce"></el-input>
            </el-form-item>

            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.id) {
            this.$http.get({
                url: '/houseKeeper/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {
                    this.formData = res.data;
                }
            })
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                keepName:
                    [
                        { required: true, message: '请输入名称', trigger: 'blur' },
                    ],
                position:
                    [
                        { required: true, message: '请输入职位', trigger: 'blur' },
                    ],
                telephone:
                    [
                        { required: true, message: '请输入电话', trigger: 'blur' },
                    ],
            },
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));
            this.$http.post({
                url: this.formData.id ? '/houseKeeper/update' : '/houseKeeper/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/houseKeeper/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
    }
}
</script>
<style lang="less" scoped>
</style>
